window.Gleam.initSearch([{"doc":"exception","title":"exception","content":"# exception\n\n[![Package Version](https://img.shields.io/hexpm/v/exception)](https://hex.pm/packages/exception)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/exception/)\n\nA tiny package for dealing with exceptions\n\n```sh\ngleam add exception\n```\n\nDocumentation can be found at &lt;https://hexdocs.pm/exception&gt;.\n","url":"index.html"},{"doc":"exception","title":"defer","content":"pub fn defer(cleanup: fn() -&gt; a, body: fn() -&gt; b) -&gt; b\n This function will run a cleanup function after the given body function, even\n if the body function crashes.\n\n You should ideally never use this function! Exceptions are not flow control\n in Gleam, a result type should be used instead. This function is only if you\n need to perform some cleanup when a crash occurs.\n\n # Examples\n \n \n pub fn run_with_lock(f: fn() -&gt; a) -&gt; a {\n   let lock = acquire()\n   use &lt;- defer(fn() { release(lock) })\n   f()\n }\n \n \n\nSynonyms:\nexception.defer\nexception defer","url":"exception.html#defer"},{"doc":"exception","title":"rescue","content":"pub fn rescue(body: fn() -&gt; a) -&gt; Result(a, Dynamic)\n This function will catch any crash and convert it into a result rather than\n crashing the process.\n\n You should ideally never use this function! Exceptions are not flow control\n in Gleam, a result type should be used instead. This function is only if you\n need to perform some cleanup when a crash occurs, and then you should favour\n `defer` if possible.\n\nSynonyms:\nexception.rescue\nexception rescue","url":"exception.html#rescue"},{"doc":"exception","title":"exception","content":"","url":"exception.html"}]);